commit 175e6b47f268e871a4c84e006ed981ce048c4184
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Tue Oct 6 09:41:16 2020 +0100

    libstdc++: Avoid CTAD for std::ranges::join_view [LWG 3474]
    
    In commit ef275d1f2083f8a1fa1b59a3cd07fd3e8431023e I implemented the
    wrong resolution of LWG 3474. This removes the deduction guide and
    alters the views::join factory to create the right type explicitly.
    
    libstdc++-v3/ChangeLog:
    
            * include/std/ranges (join_view): Remove deduction guide.
            (views::join): Add explicit template argument list to prevent
            deducing the wrong type.
            * testsuite/std/ranges/adaptors/join.cc: Move test for LWG 3474
            here, from ...
            * testsuite/std/ranges/adaptors/join_lwg3474.cc: Removed.
    
    (cherry picked from commit 9065c4adab0b1280f5707d53833d195d0d350fd2)

diff --git a/libstdc++-v3/include/std/ranges b/libstdc++-v3/include/std/ranges
index 23c54b2ae4e..5625b0ba1a3 100644
--- a/libstdc++-v3/include/std/ranges
+++ b/libstdc++-v3/include/std/ranges
@@ -2699,17 +2699,14 @@ namespace views
   template<typename _Range>
     explicit join_view(_Range&&) -> join_view<views::all_t<_Range>>;
 
-    // _GLIBCXX_RESOLVE_LIB_DEFECTS
-    // 3474. Nesting join_views is broken because of CTAD
-  template<typename _View>
-    explicit join_view(join_view<_View>) -> join_view<join_view<_View>>;
-
   namespace views
   {
     inline constexpr __adaptor::_RangeAdaptorClosure join
       = [] <viewable_range _Range> (_Range&& __r)
       {
-	return join_view{std::forward<_Range>(__r)};
+	// _GLIBCXX_RESOLVE_LIB_DEFECTS
+	// 3474. Nesting join_views is broken because of CTAD
+	return join_view<views::all_t<_Range>>{std::forward<_Range>(__r)};
       };
   } // namespace views
 
diff --git a/libstdc++-v3/testsuite/std/ranges/adaptors/join.cc b/libstdc++-v3/testsuite/std/ranges/adaptors/join.cc
index 142c9feddcd..e21e7054b35 100644
--- a/libstdc++-v3/testsuite/std/ranges/adaptors/join.cc
+++ b/libstdc++-v3/testsuite/std/ranges/adaptors/join.cc
@@ -123,6 +123,21 @@ test06()
   b = ranges::end(v);
 }
 
+void
+test07()
+{
+  // LWG 3474. Nesting join_views is broken because of CTAD
+  std::vector<std::vector<std::vector<int>>> nested_vectors = {
+    {{1, 2, 3}, {4, 5}, {6}},
+    {{7},       {8, 9}, {10, 11, 12}},
+    {{13}}
+  };
+  auto joined = nested_vectors | std::views::join | std::views::join;
+
+  using V = decltype(joined);
+  static_assert( std::same_as<std::ranges::range_value_t<V>, int> );
+}
+
 int
 main()
 {
@@ -132,4 +147,5 @@ main()
   test04();
   test05();
   test06();
+  test07();
 }
